Loading...
Searching...
No Matches
shapefil.h File Reference
`#include <stdio.h>`
Include dependency graph for shapefil.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SAHooks
struct | SHPInfo
struct | SHPDate
struct | tagSHPObject
struct | shape_tree_node
struct | SHPTree
struct | DBFInfo

## Macros

#define | SHAPELIB_VERSION_MAJOR 1
#define | SHAPELIB_VERSION_MINOR 6
#define | SHAPELIB_VERSION_MICRO 2
#define | SHAPELIB_MAKE_VERSION_NUMBER(major, minor, micro)
#define | SHAPELIB_VERSION_NUMBER
#define | SHAPELIB_AT_LEAST(major, minor, micro)
#define | TRIM_DBF_WHITESPACE
#define | DISABLE_MULTIPATCH_MEASURE
#define | SHPAPI_CALL
#define | SHPAPI_CALL1(x)
#define | SHPT_NULL 0
#define | SHPT_POINT 1
#define | SHPT_ARC 3
#define | SHPT_POLYGON 5
#define | SHPT_MULTIPOINT 8
#define | SHPT_POINTZ 11
#define | SHPT_ARCZ 13
#define | SHPT_POLYGONZ 15
#define | SHPT_MULTIPOINTZ 18
#define | SHPT_POINTM 21
#define | SHPT_ARCM 23
#define | SHPT_POLYGONM 25
#define | SHPT_MULTIPOINTM 28
#define | SHPT_MULTIPATCH 31
#define | SHPP_TRISTRIP 0
#define | SHPP_TRIFAN 1
#define | SHPP_OUTERRING 2
#define | SHPP_INNERRING 3
#define | SHPP_FIRSTRING 4
#define | SHPP_RING 5
#define | MAX_SUBNODE 4
#define | MAX_DEFAULT_TREE_DEPTH 12
#define | XBASE_FLDHDR_SZ 32
#define | XBASE_FLDNAME_LEN_READ 11
#define | XBASE_FLDNAME_LEN_WRITE 10
#define | XBASE_FLD_MAX_WIDTH 255

## Typedefs

typedef int * | SAFile
typedef unsigned long | SAOffset
typedef struct tagSHPObject | SHPObject
typedef SHPInfo * | SHPHandle
typedef struct shape_tree_node | SHPTreeNode
typedef struct SHPDiskTreeInfo * | SHPTreeDiskHandle
typedef struct SBNSearchInfo * | SBNSearchHandle
typedef struct DBFInfo | DBFInfo
typedef struct DBFInfo * | DBFHandle

## Enumerations

enum | DBFFieldType { FTString , FTInteger , FTDouble , FTLogical , FTDate , FTInvalid }

## Functions

void | SASetupDefaultHooks (SAHooks *psHooks)
SHPHandle | SHPOpen (const char *pszShapeFile, const char *pszAccess)
SHPHandle | SHPOpenLL (const char *pszShapeFile, const char *pszAccess, const SAHooks *psHooks)
SHPHandle | SHPOpenLLEx (const char *pszShapeFile, const char *pszAccess, const SAHooks *psHooks, int bRestoreSHX)
int | SHPRestoreSHX (const char *pszShapeFile, const char *pszAccess, const SAHooks *psHooks)
void | SHPSetFastModeReadObject (SHPHandle hSHP, int bFastMode)
SHPHandle | SHPCreate (const char *pszShapeFile, int nShapeType)
SHPHandle | SHPCreateLL (const char *pszShapeFile, int nShapeType, const SAHooks *psHooks)
void | SHPGetInfo (const SHPHandle hSHP, int *pnEntities, int *pnShapeType, double *padfMinBound, double *padfMaxBound)
SHPObject * | SHPReadObject (const SHPHandle hSHP, int iShape)
int | SHPWriteObject (SHPHandle hSHP, int iShape, const SHPObject *psObject)
void | SHPDestroyObject (SHPObject *psObject)
void | SHPComputeExtents (SHPObject *psObject)
SHPObject * | SHPCreateObject (int nSHPType, int nShapeId, int nParts, const int *panPartStart, const int *panPartType, int nVertices, const double *padfX, const double *padfY, const double *padfZ, const double *padfM)
SHPObject * | SHPCreateSimpleObject (int nSHPType, int nVertices, const double *padfX, const double *padfY, const double *padfZ)
int | SHPRewindObject (const SHPHandle hSHP, SHPObject *psObject)
void | SHPClose (SHPHandle hSHP)
void | SHPWriteHeader (SHPHandle hSHP)
const char * | SHPTypeName (int nSHPType)
const char * | SHPPartTypeName (int nPartType)
SHPTree * | SHPCreateTree (SHPHandle hSHP, int nDimension, int nMaxDepth, const double *padfBoundsMin, const double *padfBoundsMax)
void | SHPDestroyTree (SHPTree *hTree)
int | SHPWriteTree (SHPTree *hTree, const char *pszFilename)
int | SHPTreeAddShapeId (SHPTree *hTree, SHPObject *psObject)
void | SHPTreeTrimExtraNodes (SHPTree *hTree)
int * | SHPTreeFindLikelyShapes (const SHPTree *hTree, double *padfBoundsMin, double *padfBoundsMax, int *)
int | SHPCheckBoundsOverlap (const double *, const double *, const double *, const double *, int)
int * | SHPSearchDiskTree (FILE *fp, double *padfBoundsMin, double *padfBoundsMax, int *pnShapeCount)
SHPTreeDiskHandle | SHPOpenDiskTree (const char *pszQIXFilename, const SAHooks *psHooks)
void | SHPCloseDiskTree (SHPTreeDiskHandle hDiskTree)
int * | SHPSearchDiskTreeEx (const SHPTreeDiskHandle hDiskTree, double *padfBoundsMin, double *padfBoundsMax, int *pnShapeCount)
int | SHPWriteTreeLL (SHPTree *hTree, const char *pszFilename, const SAHooks *psHooks)
SBNSearchHandle | SBNOpenDiskTree (const char *pszSBNFilename, const SAHooks *psHooks)
void | SBNCloseDiskTree (SBNSearchHandle hSBN)
int * | SBNSearchDiskTree (const SBNSearchHandle hSBN, const double *padfBoundsMin, const double *padfBoundsMax, int *pnShapeCount)
int * | SBNSearchDiskTreeInteger (const SBNSearchHandle hSBN, int bMinX, int bMinY, int bMaxX, int bMaxY, int *pnShapeCount)
void | SBNSearchFreeIds (int *panShapeId)
DBFHandle | DBFOpen (const char *pszDBFFile, const char *pszAccess)
DBFHandle | DBFOpenLL (const char *pszDBFFile, const char *pszAccess, const SAHooks *psHooks)
DBFHandle | DBFCreate (const char *pszDBFFile)
DBFHandle | DBFCreateEx (const char *pszDBFFile, const char *pszCodePage)
DBFHandle | DBFCreateLL (const char *pszDBFFile, const char *pszCodePage, const SAHooks *psHooks)
int | DBFGetFieldCount (const DBFHandle psDBF)
int | DBFGetRecordCount (const DBFHandle psDBF)
int | DBFAddField (DBFHandle hDBF, const char *pszFieldName, DBFFieldType eType, int nWidth, int nDecimals)
int | DBFAddNativeFieldType (DBFHandle hDBF, const char *pszFieldName, char chType, int nWidth, int nDecimals)
int | DBFDeleteField (DBFHandle hDBF, int iField)
int | DBFReorderFields (DBFHandle psDBF, const int *panMap)
int | DBFAlterFieldDefn (DBFHandle psDBF, int iField, const char *pszFieldName, char chType, int nWidth, int nDecimals)
DBFFieldType | DBFGetFieldInfo (const DBFHandle psDBF, int iField, char *pszFieldName, int *pnWidth, int *pnDecimals)
int | DBFGetFieldIndex (const DBFHandle psDBF, const char *pszFieldName)
int | DBFReadIntegerAttribute (DBFHandle hDBF, int iShape, int iField)
double | DBFReadDoubleAttribute (DBFHandle hDBF, int iShape, int iField)
const char * | DBFReadStringAttribute (DBFHandle hDBF, int iShape, int iField)
const char * | DBFReadLogicalAttribute (DBFHandle hDBF, int iShape, int iField)
SHPDate | DBFReadDateAttribute (DBFHandle hDBF, int iShape, int iField)
int | DBFIsAttributeNULL (const DBFHandle hDBF, int iShape, int iField)
int | DBFWriteIntegerAttribute (DBFHandle hDBF, int iShape, int iField, int nFieldValue)
int | DBFWriteDoubleAttribute (DBFHandle hDBF, int iShape, int iField, double dFieldValue)
int | DBFWriteStringAttribute (DBFHandle hDBF, int iShape, int iField, const char *pszFieldValue)
int | DBFWriteNULLAttribute (DBFHandle hDBF, int iShape, int iField)
int | DBFWriteLogicalAttribute (DBFHandle hDBF, int iShape, int iField, const char lFieldValue)
int | DBFWriteDateAttribute (DBFHandle hDBF, int iShape, int iField, const SHPDate *dateFieldValue)
int | DBFWriteAttributeDirectly (DBFHandle psDBF, int hEntity, int iField, const void *pValue)
const char * | DBFReadTuple (DBFHandle psDBF, int hEntity)
int | DBFWriteTuple (DBFHandle psDBF, int hEntity, const void *pRawTuple)
int | DBFIsRecordDeleted (const DBFHandle psDBF, int iShape)
int | DBFMarkRecordDeleted (DBFHandle psDBF, int iShape, int bIsDeleted)
DBFHandle | DBFCloneEmpty (const DBFHandle psDBF, const char *pszFilename)
void | DBFClose (DBFHandle hDBF)
void | DBFUpdateHeader (DBFHandle hDBF)
char | DBFGetNativeFieldType (const DBFHandle hDBF, int iField)
const char * | DBFGetCodePage (const DBFHandle psDBF)
void | DBFSetLastModifiedDate (DBFHandle psDBF, int nYYSince1900, int nMM, int nDD)
void | DBFSetWriteEndOfFileChar (DBFHandle psDBF, int bWriteFlag)

## Macro Definition Documentation

## DISABLE_MULTIPATCH_MEASURE

#define DISABLE_MULTIPATCH_MEASURE

Definition at line 64 of file shapefil.h.

Referenced by SHPWriteObject().

## MAX_DEFAULT_TREE_DEPTH

#define MAX_DEFAULT_TREE_DEPTH 12

Definition at line 324 of file shapefil.h.

## MAX_SUBNODE

#define MAX_SUBNODE 4

Definition at line 321 of file shapefil.h.

## SHAPELIB_AT_LEAST

#define SHAPELIB_AT_LEAST | ( |  | major,
|  |  | minor,
|  |  | micro )

Value:
(SHAPELIB_VERSION_NUMBER >= \
SHAPELIB_MAKE_VERSION_NUMBER(major, minor, micro))
SHAPELIB_VERSION_NUMBER
#define SHAPELIB_VERSION_NUMBER
Definition shapefil.h:40

Definition at line 45 of file shapefil.h.

## SHAPELIB_MAKE_VERSION_NUMBER

#define SHAPELIB_MAKE_VERSION_NUMBER | ( |  | major,
|  |  | minor,
|  |  | micro )

Value:
((major) * 10000 + (minor) * 100 + (micro))

Definition at line 37 of file shapefil.h.

## SHAPELIB_VERSION_MAJOR

#define SHAPELIB_VERSION_MAJOR 1

Definition at line 33 of file shapefil.h.

## SHAPELIB_VERSION_MICRO

#define SHAPELIB_VERSION_MICRO 2

Definition at line 35 of file shapefil.h.

## SHAPELIB_VERSION_MINOR

#define SHAPELIB_VERSION_MINOR 6

Definition at line 34 of file shapefil.h.

## SHAPELIB_VERSION_NUMBER

#define SHAPELIB_VERSION_NUMBER

Value:
SHAPELIB_MAKE_VERSION_NUMBER(SHAPELIB_VERSION_MAJOR, \
SHAPELIB_VERSION_MINOR, \
SHAPELIB_VERSION_MICRO)
SHAPELIB_MAKE_VERSION_NUMBER
#define SHAPELIB_MAKE_VERSION_NUMBER(major, minor, micro)
Definition shapefil.h:37
SHAPELIB_VERSION_MINOR
#define SHAPELIB_VERSION_MINOR
Definition shapefil.h:34
SHAPELIB_VERSION_MICRO
#define SHAPELIB_VERSION_MICRO
Definition shapefil.h:35
SHAPELIB_VERSION_MAJOR
#define SHAPELIB_VERSION_MAJOR
Definition shapefil.h:33

Definition at line 40 of file shapefil.h.

## SHPAPI_CALL

#define SHPAPI_CALL

Definition at line 105 of file shapefil.h.

Referenced by DBFAddField(), DBFAddNativeFieldType(), DBFAlterFieldDefn(), DBFCloneEmpty(), DBFClose(), DBFCreate(), DBFCreateEx(), DBFCreateLL(), DBFDeleteField(), DBFGetFieldCount(), DBFGetFieldIndex(), DBFGetFieldInfo(), DBFGetNativeFieldType(), DBFGetRecordCount(), DBFIsAttributeNULL(), DBFIsRecordDeleted(), DBFMarkRecordDeleted(), DBFOpen(), DBFOpenLL(), DBFReadDateAttribute(), DBFReadDoubleAttribute(), DBFReadIntegerAttribute(), DBFReorderFields(), DBFSetLastModifiedDate(), DBFSetWriteEndOfFileChar(), DBFUpdateHeader(), DBFWriteAttributeDirectly(), DBFWriteDateAttribute(), DBFWriteDoubleAttribute(), DBFWriteIntegerAttribute(), DBFWriteLogicalAttribute(), DBFWriteNULLAttribute(), DBFWriteStringAttribute(), DBFWriteTuple(), SBNCloseDiskTree(), SBNOpenDiskTree(), SBNSearchFreeIds(), SHPCheckBoundsOverlap(), SHPClose(), SHPCloseDiskTree(), SHPComputeExtents(), SHPCreate(), SHPCreateLL(), SHPDestroyObject(), SHPDestroyTree(), SHPGetInfo(), SHPOpen(), SHPOpenDiskTree(), SHPOpenLL(), SHPOpenLLEx(), SHPRestoreSHX(), SHPRewindObject(), SHPSetFastModeReadObject(), SHPTreeAddShapeId(), SHPTreeTrimExtraNodes(), SHPWriteHeader(), SHPWriteObject(), SHPWriteTree(), and SHPWriteTreeLL().

## SHPAPI_CALL1

#define SHPAPI_CALL1 | ( |  | x | ) |

Value:
x SHPAPI_CALL
SHPAPI_CALL
#define SHPAPI_CALL
Definition shapefil.h:105
x
#define x

Definition at line 110 of file shapefil.h.

Referenced by SBNCloseDiskTree(), SBNSearchDiskTree(), SHPCloseDiskTree(), SHPSearchDiskTree(), and SHPTreeTrimExtraNodes().

## SHPP_FIRSTRING

#define SHPP_FIRSTRING 4

Definition at line 225 of file shapefil.h.

Referenced by SHPPartTypeName().

## SHPP_INNERRING

#define SHPP_INNERRING 3

Definition at line 224 of file shapefil.h.

Referenced by SHPPartTypeName().

## SHPP_OUTERRING

#define SHPP_OUTERRING 2

Definition at line 223 of file shapefil.h.

Referenced by SHPPartTypeName().

## SHPP_RING

#define SHPP_RING 5

Definition at line 226 of file shapefil.h.

Referenced by SHPCreateObject(), and SHPPartTypeName().

## SHPP_TRIFAN

#define SHPP_TRIFAN 1

Definition at line 222 of file shapefil.h.

Referenced by SHPPartTypeName().

## SHPP_TRISTRIP

#define SHPP_TRISTRIP 0

Definition at line 221 of file shapefil.h.

Referenced by SHPPartTypeName().

## SHPT_ARC

#define SHPT_ARC 3

Definition at line 203 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_ARCM

#define SHPT_ARCM 23

Definition at line 211 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_ARCZ

#define SHPT_ARCZ 13

Definition at line 207 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_MULTIPATCH

#define SHPT_MULTIPATCH 31

Definition at line 214 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_MULTIPOINT

#define SHPT_MULTIPOINT 8

Definition at line 205 of file shapefil.h.

Referenced by SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_MULTIPOINTM

#define SHPT_MULTIPOINTM 28

Definition at line 213 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_MULTIPOINTZ

#define SHPT_MULTIPOINTZ 18

Definition at line 209 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_NULL

#define SHPT_NULL 0

Definition at line 201 of file shapefil.h.

Referenced by SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_POINT

#define SHPT_POINT 1

Definition at line 202 of file shapefil.h.

Referenced by SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_POINTM

#define SHPT_POINTM 21

Definition at line 210 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_POINTZ

#define SHPT_POINTZ 11

Definition at line 206 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPTypeName(), and SHPWriteObject().

## SHPT_POLYGON

#define SHPT_POLYGON 5

Definition at line 204 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPRewindObject(), SHPTypeName(), and SHPWriteObject().

## SHPT_POLYGONM

#define SHPT_POLYGONM 25

Definition at line 212 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPRewindObject(), SHPTypeName(), and SHPWriteObject().

## SHPT_POLYGONZ

#define SHPT_POLYGONZ 15

Definition at line 208 of file shapefil.h.

Referenced by SHPCreateObject(), SHPRestoreSHX(), SHPRewindObject(), SHPTypeName(), and SHPWriteObject().

## TRIM_DBF_WHITESPACE

#define TRIM_DBF_WHITESPACE

Definition at line 57 of file shapefil.h.

## XBASE_FLD_MAX_WIDTH

#define XBASE_FLD_MAX_WIDTH 255

Definition at line 475 of file shapefil.h.

Referenced by DBFAddNativeFieldType(), and DBFAlterFieldDefn().

## XBASE_FLDHDR_SZ

#define XBASE_FLDHDR_SZ 32

Definition at line 469 of file shapefil.h.

Referenced by DBFAddNativeFieldType(), DBFAlterFieldDefn(), DBFCloneEmpty(), DBFDeleteField(), DBFGetFieldInfo(), DBFOpenLL(), and DBFReorderFields().

## XBASE_FLDNAME_LEN_READ

#define XBASE_FLDNAME_LEN_READ 11

Definition at line 471 of file shapefil.h.

Referenced by DBFGetFieldIndex(), and DBFGetFieldInfo().

## XBASE_FLDNAME_LEN_WRITE

#define XBASE_FLDNAME_LEN_WRITE 10

Definition at line 473 of file shapefil.h.

Referenced by DBFAddNativeFieldType(), and DBFAlterFieldDefn().

## Typedef Documentation

## DBFHandle

typedef struct DBFInfo* DBFHandle

Definition at line 457 of file shapefil.h.

## DBFInfo

typedef struct DBFInfo DBFInfo

## SAFile

typedef int* SAFile

Definition at line 125 of file shapefil.h.

## SAOffset

typedef unsigned long SAOffset

Definition at line 131 of file shapefil.h.

## SBNSearchHandle

typedef struct SBNSearchInfo* SBNSearchHandle

Definition at line 391 of file shapefil.h.

## SHPHandle

typedef SHPInfo* SHPHandle

Definition at line 190 of file shapefil.h.

## SHPObject

typedef struct tagSHPObject SHPObject

Definition at line 159 of file shapefil.h.

## SHPTreeDiskHandle

typedef struct SHPDiskTreeInfo* SHPTreeDiskHandle

Definition at line 372 of file shapefil.h.

## SHPTreeNode

typedef struct shape_tree_node SHPTreeNode

## Enumeration Type Documentation

## DBFFieldType

enum DBFFieldType

Enumerator
FTString |
FTInteger |
FTDouble |
FTLogical |
FTDate |
FTInvalid |

Definition at line 459 of file shapefil.h.

## Function Documentation

## DBFAddField()

int DBFAddField | ( | DBFHandle | hDBF,
|  | const char * | pszFieldName,
|  | DBFFieldType | eType,
|  | int | nWidth,
|  | int | nDecimals )

Definition at line 751 of file dbfopen.c.

References DBFAddNativeFieldType(), FTDate, FTLogical, FTString, and SHPAPI_CALL.

## DBFAddNativeFieldType()

int DBFAddNativeFieldType | ( | DBFHandle | hDBF,
|  | const char * | pszFieldName,
|  | char | chType,
|  | int | nWidth,
|  | int | nDecimals )

Definition at line 795 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, DBFInfo::bWriteEndOfFileChar, DBFUpdateHeader(), END_OF_FILE_CHARACTER, SAHooks::Error, FALSE, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, DBFInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, TRUE, XBASE_FLD_MAX_WIDTH, XBASE_FLDHDR_SZ, and XBASE_FLDNAME_LEN_WRITE.

Referenced by DBFAddField().

## DBFAlterFieldDefn()

int DBFAlterFieldDefn | ( | DBFHandle | psDBF,
|  | int | iField,
|  | const char * | pszFieldName,
|  | char | chType,
|  | int | nWidth,
|  | int | nDecimals )

Definition at line 2109 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, DBFInfo::bWriteEndOfFileChar, DBFUpdateHeader(), END_OF_FILE_CHARACTER, FALSE, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, DBFInfo::sHooks, SHPAPI_CALL, STATIC_CAST, TRUE, XBASE_FLD_MAX_WIDTH, XBASE_FLDHDR_SZ, and XBASE_FLDNAME_LEN_WRITE.

## DBFCloneEmpty()

DBFHandle DBFCloneEmpty | ( | const DBFHandle | psDBF,
|  | const char * | pszFilename )

Definition at line 1680 of file dbfopen.c.

References DBFInfo::bNoHeader, DBFInfo::bUpdated, DBFInfo::bWriteEndOfFileChar, DBFClose(), DBFCreateLL(), DBFOpen(), DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCodePage, DBFInfo::pszHeader, DBFInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, TRUE, and XBASE_FLDHDR_SZ.

## DBFClose()

void DBFClose | ( | DBFHandle | hDBF | ) |

Definition at line 568 of file dbfopen.c.

References DBFInfo::bNoHeader, DBFInfo::bUpdated, CPL_IGNORE_RET_VAL_INT, DBFUpdateHeader(), SAHooks::FClose, DBFInfo::fp, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCodePage, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, DBFInfo::pszWorkField, DBFInfo::sHooks, SHPAPI_CALL, and SHPLIB_NULLPTR.

Referenced by DBFCloneEmpty(), and DBFOpenLL().

## DBFCreate()

DBFHandle DBFCreate | ( | const char * | pszDBFFile | ) |

Definition at line 616 of file dbfopen.c.

References DBFCreateEx(), and SHPAPI_CALL.

## DBFCreateEx()

DBFHandle DBFCreateEx | ( | const char * | pszDBFFile,
|  | const char * | pszCodePage )

Definition at line 627 of file dbfopen.c.

References DBFCreateLL(), SASetupDefaultHooks(), and SHPAPI_CALL.

Referenced by DBFCreate().

## DBFCreateLL()

DBFHandle DBFCreateLL | ( | const char * | pszDBFFile,
|  | const char * | pszCodePage,
|  | const SAHooks * | psHooks )

Definition at line 643 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bRequireNextWriteSeek, CONST_CAST, DBFSetLastModifiedDate(), DBFSetWriteEndOfFileChar(), SAHooks::Error, FALSE, SAHooks::FClose, SAHooks::FOpen, DBFInfo::fp, SAHooks::FWrite, DBFInfo::iLanguageDriver, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCodePage, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, SAHooks::pvUserData, SAHooks::Remove, DBFInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, strcpy, TRUE, and XBASE_FILEHDR_SZ.

Referenced by DBFCloneEmpty(), and DBFCreateEx().

## DBFDeleteField()

int DBFDeleteField | ( | DBFHandle | hDBF,
|  | int | iField )

Definition at line 1847 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, DBFInfo::bWriteEndOfFileChar, DBFUpdateHeader(), END_OF_FILE_CHARACTER, FALSE, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, DBFInfo::sHooks, SHPAPI_CALL, STATIC_CAST, TRUE, and XBASE_FLDHDR_SZ.

## DBFGetCodePage()

const char * DBFGetCodePage | ( | const DBFHandle | psDBF | ) |

Definition at line 1834 of file dbfopen.c.

References DBFGetCodePage(), and SHPLIB_NULLPTR.

Referenced by DBFGetCodePage().

## DBFGetFieldCount()

int DBFGetFieldCount | ( | const DBFHandle | psDBF | ) |

Definition at line 1253 of file dbfopen.c.

References DBFInfo::nFields, and SHPAPI_CALL.

Referenced by DBFGetFieldIndex().

## DBFGetFieldIndex()

int DBFGetFieldIndex | ( | const DBFHandle | psDBF,
|  | const char * | pszFieldName )

Definition at line 1756 of file dbfopen.c.

References DBFGetFieldCount(), DBFGetFieldInfo(), name, SHPAPI_CALL, SHPLIB_NULLPTR, STRCASECMP, and XBASE_FLDNAME_LEN_READ.

## DBFGetFieldInfo()

DBFFieldType DBFGetFieldInfo | ( | const DBFHandle | psDBF,
|  | int | iField,
|  | char * | pszFieldName,
|  | int * | pnWidth,
|  | int * | pnDecimals )

Definition at line 1277 of file dbfopen.c.

References FTDate, FTDouble, FTInteger, FTInvalid, FTLogical, FTString, DBFInfo::nFields, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldSize, DBFInfo::pszHeader, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, XBASE_FLDHDR_SZ, and XBASE_FLDNAME_LEN_READ.

Referenced by DBFGetFieldIndex().

## DBFGetNativeFieldType()

char DBFGetNativeFieldType | ( | const DBFHandle | hDBF,
|  | int | iField )

Definition at line 1740 of file dbfopen.c.

References DBFInfo::pachFieldType, and SHPAPI_CALL.

## DBFGetRecordCount()

int DBFGetRecordCount | ( | const DBFHandle | psDBF | ) |

Definition at line 1264 of file dbfopen.c.

References DBFInfo::nRecords, and SHPAPI_CALL.

## DBFIsAttributeNULL()

int DBFIsAttributeNULL | ( | const DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1235 of file dbfopen.c.

References DBFReadStringAttribute(), DBFInfo::pachFieldType, DBFInfo::panFieldSize, SHPAPI_CALL, SHPLIB_NULLPTR, and TRUE.

## DBFIsRecordDeleted()

int DBFIsRecordDeleted | ( | const DBFHandle | psDBF,
|  | int | iShape )

Definition at line 1776 of file dbfopen.c.

References FALSE, DBFInfo::nRecords, DBFInfo::pszCurrentRecord, SHPAPI_CALL, and TRUE.

## DBFMarkRecordDeleted()

int DBFMarkRecordDeleted | ( | DBFHandle | psDBF,
|  | int | iShape,
|  | int | bIsDeleted )

Definition at line 1800 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bUpdated, FALSE, DBFInfo::nRecords, DBFInfo::pszCurrentRecord, SHPAPI_CALL, and TRUE.

## DBFOpen()

DBFHandle DBFOpen | ( | const char * | pszDBFFile,
|  | const char * | pszAccess )

Definition at line 300 of file dbfopen.c.

References DBFOpenLL(), SASetupDefaultHooks(), and SHPAPI_CALL.

Referenced by DBFCloneEmpty().

## DBFOpenLL()

DBFHandle DBFOpenLL | ( | const char * | pszDBFFile,
|  | const char * | pszAccess,
|  | const SAHooks * | psHooks )

Definition at line 331 of file dbfopen.c.

References assert, DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bRequireNextWriteSeek, DBFClose(), DBFSetLastModifiedDate(), DBFSetWriteEndOfFileChar(), FALSE, SAHooks::FClose, SAHooks::FOpen, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, HEADER_RECORD_TERMINATOR, DBFInfo::iLanguageDriver, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCodePage, DBFInfo::pszCurrentRecord, DBFInfo::pszHeader, SAHooks::pvUserData, REINTERPRET_CAST, DBFInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, strcpy, TRUE, XBASE_FILEHDR_SZ, and XBASE_FLDHDR_SZ.

Referenced by DBFOpen().

## DBFReadDateAttribute()

SHPDate DBFReadDateAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1146 of file dbfopen.c.

References SHPDate::day, SHPDate::month, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, and SHPDate::year.

## DBFReadDoubleAttribute()

double DBFReadDoubleAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1102 of file dbfopen.c.

References SHPAPI_CALL, SHPLIB_NULLPTR, and STATIC_CAST.

## DBFReadIntegerAttribute()

int DBFReadIntegerAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1084 of file dbfopen.c.

References SHPAPI_CALL, SHPLIB_NULLPTR, and STATIC_CAST.

## DBFReadLogicalAttribute()

const char * DBFReadLogicalAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1134 of file dbfopen.c.

References DBFReadLogicalAttribute(), and STATIC_CAST.

Referenced by DBFReadLogicalAttribute().

## DBFReadStringAttribute()

const char * DBFReadStringAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1121 of file dbfopen.c.

References DBFReadStringAttribute(), and STATIC_CAST.

Referenced by DBFIsAttributeNULL(), and DBFReadStringAttribute().

## DBFReadTuple()

const char * DBFReadTuple | ( | DBFHandle | psDBF,
|  | int | hEntity )

Definition at line 1662 of file dbfopen.c.

References DBFReadTuple(), SHPLIB_NULLPTR, and STATIC_CAST.

Referenced by DBFReadTuple().

## DBFReorderFields()

int DBFReorderFields | ( | DBFHandle | psDBF,
|  | const int * | panMap )

Definition at line 1972 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, DBFUpdateHeader(), SAHooks::Error, FALSE, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, DBFInfo::nCurrentRecord, DBFInfo::nFields, DBFInfo::nHeaderLength, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pachFieldType, DBFInfo::panFieldDecimals, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszHeader, DBFInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, STATIC_CAST, TRUE, and XBASE_FLDHDR_SZ.

## DBFSetLastModifiedDate()

void DBFSetLastModifiedDate | ( | DBFHandle | psDBF,
|  | int | nYYSince1900,
|  | int | nMM,
|  | int | nDD )

Definition at line 286 of file dbfopen.c.

References DBFInfo::nUpdateDay, DBFInfo::nUpdateMonth, DBFInfo::nUpdateYearSince1900, and SHPAPI_CALL.

Referenced by DBFCreateLL(), and DBFOpenLL().

## DBFSetWriteEndOfFileChar()

void DBFSetWriteEndOfFileChar | ( | DBFHandle | psDBF,
|  | int | bWriteFlag )

Definition at line 2357 of file dbfopen.c.

References DBFInfo::bWriteEndOfFileChar, and SHPAPI_CALL.

Referenced by DBFCreateLL(), and DBFOpenLL().

## DBFUpdateHeader()

void DBFUpdateHeader | ( | DBFHandle | hDBF | ) |

Definition at line 252 of file dbfopen.c.

References DBFInfo::bNoHeader, SAHooks::FFlush, DBFInfo::fp, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, DBFInfo::nRecords, DBFInfo::nUpdateDay, DBFInfo::nUpdateMonth, DBFInfo::nUpdateYearSince1900, DBFInfo::sHooks, SHPAPI_CALL, STATIC_CAST, and XBASE_FILEHDR_SZ.

Referenced by DBFAddNativeFieldType(), DBFAlterFieldDefn(), DBFClose(), DBFDeleteField(), and DBFReorderFields().

## DBFWriteAttributeDirectly()

int DBFWriteAttributeDirectly | ( | DBFHandle | psDBF,
|  | int | hEntity,
|  | int | iField,
|  | const void * | pValue )

Definition at line 1451 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, FALSE, DBFInfo::nCurrentRecord, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::panFieldOffset, DBFInfo::panFieldSize, DBFInfo::pszCurrentRecord, REINTERPRET_CAST, SHPAPI_CALL, STATIC_CAST, and TRUE.

Referenced by DBFWriteDateAttribute().

## DBFWriteDateAttribute()

int DBFWriteDateAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField,
|  | const SHPDate * | dateFieldValue )

Definition at line 1587 of file dbfopen.c.

References SHPDate::day, DBFWriteAttributeDirectly(), SHPDate::month, SHPAPI_CALL, SHPLIB_NULLPTR, and SHPDate::year.

## DBFWriteDoubleAttribute()

int DBFWriteDoubleAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField,
|  | double | dFieldValue )

Definition at line 1520 of file dbfopen.c.

References SHPAPI_CALL, and STATIC_CAST.

## DBFWriteIntegerAttribute()

int DBFWriteIntegerAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField,
|  | int | nFieldValue )

Definition at line 1533 of file dbfopen.c.

References SHPAPI_CALL, and STATIC_CAST.

## DBFWriteLogicalAttribute()

int DBFWriteLogicalAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField,
|  | const char | lFieldValue )

Definition at line 1573 of file dbfopen.c.

References CONST_CAST, SHPAPI_CALL, and STATIC_CAST.

## DBFWriteNULLAttribute()

int DBFWriteNULLAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField )

Definition at line 1562 of file dbfopen.c.

References SHPAPI_CALL, and SHPLIB_NULLPTR.

## DBFWriteStringAttribute()

int DBFWriteStringAttribute | ( | DBFHandle | hDBF,
|  | int | iShape,
|  | int | iField,
|  | const char * | pszFieldValue )

Definition at line 1548 of file dbfopen.c.

References CONST_CAST, SHPAPI_CALL, and STATIC_CAST.

## DBFWriteTuple()

int DBFWriteTuple | ( | DBFHandle | psDBF,
|  | int | hEntity,
|  | const void * | pRawTuple )

Definition at line 1611 of file dbfopen.c.

References DBFInfo::bCurrentRecordModified, DBFInfo::bNoHeader, DBFInfo::bUpdated, FALSE, DBFInfo::nCurrentRecord, DBFInfo::nRecordLength, DBFInfo::nRecords, DBFInfo::pszCurrentRecord, REINTERPRET_CAST, SHPAPI_CALL, and TRUE.

## SASetupDefaultHooks()

void SASetupDefaultHooks | ( | SAHooks * | psHooks | ) |

Definition at line 91 of file safileio.c.

References SAHooks::Atof, SAHooks::Error, SAHooks::FClose, SAHooks::FFlush, SAHooks::FOpen, SAHooks::FRead, SAHooks::FSeek, SAHooks::FTell, SAHooks::FWrite, SAHooks::pvUserData, SAHooks::Remove, and SHPLIB_NULLPTR.

Referenced by DBFCreateEx(), DBFOpen(), SHPCreate(), and SHPOpen().

## SBNCloseDiskTree()

void SBNCloseDiskTree | ( | SBNSearchHandle | hSBN | ) |

References SBNCloseDiskTree(), SHPAPI_CALL, and SHPAPI_CALL1.

Referenced by SBNCloseDiskTree().

## SBNOpenDiskTree()

SBNSearchHandle SBNOpenDiskTree | ( | const char * | pszSBNFilename,
|  | const SAHooks * | psHooks )

References SBNOpenDiskTree(), and SHPAPI_CALL.

Referenced by SBNOpenDiskTree().

## SBNSearchDiskTree()

int * SBNSearchDiskTree | ( | const SBNSearchHandle | hSBN,
|  | const double * | padfBoundsMin,
|  | const double * | padfBoundsMax,
|  | int * | pnShapeCount )

References SBNSearchDiskTree(), and SHPAPI_CALL1.

Referenced by SBNSearchDiskTree().

## SBNSearchDiskTreeInteger()

int * SBNSearchDiskTreeInteger | ( | const SBNSearchHandle | hSBN,
|  | int | bMinX,
|  | int | bMinY,
|  | int | bMaxX,
|  | int | bMaxY,
|  | int * | pnShapeCount )

References SBNSearchDiskTreeInteger().

Referenced by SBNSearchDiskTreeInteger().

## SBNSearchFreeIds()

void SBNSearchFreeIds | ( | int * | panShapeId | ) |

References SBNSearchFreeIds(), and SHPAPI_CALL.

Referenced by SBNSearchFreeIds().

## SHPCheckBoundsOverlap()

int SHPCheckBoundsOverlap | ( | const double * | ,
|  | const double * | ,
|  | const double * | ,
|  | const double * | ,
|  | int | )

References SHPAPI_CALL, and SHPCheckBoundsOverlap().

Referenced by SHPCheckBoundsOverlap().

## SHPClose()

void SHPClose | ( | SHPHandle | hSHP | ) |

Definition at line 851 of file shpopen.c.

References SHPInfo::bUpdated, SAHooks::FClose, SHPInfo::fpSHP, SHPInfo::fpSHX, SHPInfo::pabyObjectBuf, SHPInfo::pabyRec, SHPInfo::panRecOffset, SHPInfo::panRecSize, SHPInfo::psCachedObject, SHPInfo::sHooks, SHPAPI_CALL, SHPLIB_NULLPTR, and SHPWriteHeader().

Referenced by SHPOpenLL().

## SHPCloseDiskTree()

void SHPCloseDiskTree | ( | SHPTreeDiskHandle | hDiskTree | ) |

References SHPAPI_CALL, SHPAPI_CALL1, and SHPCloseDiskTree().

Referenced by SHPCloseDiskTree().

## SHPComputeExtents()

void SHPComputeExtents | ( | SHPObject * | psObject | ) |

Definition at line 1147 of file shpopen.c.

References tagSHPObject::dfMMax, tagSHPObject::dfMMin, tagSHPObject::dfXMax, tagSHPObject::dfXMin, tagSHPObject::dfYMax, tagSHPObject::dfYMin, tagSHPObject::dfZMax, tagSHPObject::dfZMin, MAX, MIN, tagSHPObject::nVertices, tagSHPObject::padfM, tagSHPObject::padfX, tagSHPObject::padfY, tagSHPObject::padfZ, and SHPAPI_CALL.

Referenced by SHPCreateObject().

## SHPCreate()

SHPHandle SHPCreate | ( | const char * | pszShapeFile,
|  | int | nShapeType )

Definition at line 944 of file shpopen.c.

References SASetupDefaultHooks(), SHPAPI_CALL, and SHPCreateLL().

## SHPCreateLL()

SHPHandle SHPCreateLL | ( | const char * | pszShapeFile,
|  | int | nShapeType,
|  | const SAHooks * | psHooks )

Definition at line 960 of file shpopen.c.

References SHPInfo::bUpdated, ByteCopy, SAHooks::Error, FALSE, SAHooks::FClose, SAHooks::FOpen, SHPInfo::fpSHP, SHPInfo::fpSHX, SAHooks::FWrite, SHPInfo::nFileSize, SHPInfo::nShapeType, SHPInfo::panRecOffset, SHPInfo::panRecSize, SAHooks::pvUserData, SHPInfo::sHooks, SHP_SWAP32, SHPAPI_CALL, SHPLIB_NULLPTR, and STATIC_CAST.

Referenced by SHPCreate().

## SHPCreateObject()

SHPObject * SHPCreateObject | ( | int | nSHPType,
|  | int | nShapeId,
|  | int | nParts,
|  | const int * | panPartStart,
|  | const int * | panPartType,
|  | int | nVertices,
|  | const double * | padfX,
|  | const double * | padfY,
|  | const double * | padfZ,
|  | const double * | padfM )

Definition at line 1180 of file shpopen.c.

References tagSHPObject::bMeasureIsUsed, FALSE, MAX, tagSHPObject::nParts, tagSHPObject::nShapeId, tagSHPObject::nSHPType, tagSHPObject::nVertices, tagSHPObject::padfM, tagSHPObject::padfX, tagSHPObject::padfY, tagSHPObject::padfZ, tagSHPObject::panPartStart, tagSHPObject::panPartType, SHPComputeExtents(), SHPCreateObject(), SHPLIB_NULLPTR, SHPP_RING, SHPT_ARC, SHPT_ARCM, SHPT_ARCZ, SHPT_MULTIPATCH, SHPT_MULTIPOINTM, SHPT_MULTIPOINTZ, SHPT_POINTM, SHPT_POINTZ, SHPT_POLYGON, SHPT_POLYGONM, SHPT_POLYGONZ, STATIC_CAST, and TRUE.

Referenced by SHPCreateObject(), and SHPCreateSimpleObject().

## SHPCreateSimpleObject()

SHPObject * SHPCreateSimpleObject | ( | int | nSHPType,
|  | int | nVertices,
|  | const double * | padfX,
|  | const double * | padfY,
|  | const double * | padfZ )

Definition at line 1309 of file shpopen.c.

References SHPCreateObject(), SHPCreateSimpleObject(), and SHPLIB_NULLPTR.

Referenced by SHPCreateSimpleObject().

## SHPCreateTree()

SHPTree * SHPCreateTree | ( | SHPHandle | hSHP,
|  | int | nDimension,
|  | int | nMaxDepth,
|  | const double * | padfBoundsMin,
|  | const double * | padfBoundsMax )

References SHPCreateTree().

Referenced by SHPCreateTree().

## SHPDestroyObject()

void SHPDestroyObject | ( | SHPObject * | psObject | ) |

Definition at line 2725 of file shpopen.c.

References tagSHPObject::bFastModeReadObject, FALSE, tagSHPObject::padfM, tagSHPObject::padfX, tagSHPObject::padfY, tagSHPObject::padfZ, tagSHPObject::panPartStart, tagSHPObject::panPartType, SHPAPI_CALL, and SHPLIB_NULLPTR.

## SHPDestroyTree()

void SHPDestroyTree | ( | SHPTree * | hTree | ) |

References SHPAPI_CALL, and SHPDestroyTree().

Referenced by SHPDestroyTree().

## SHPGetInfo()

void SHPGetInfo | ( | const SHPHandle | hSHP,
|  | int * | pnEntities,
|  | int * | pnShapeType,
|  | double * | padfMinBound,
|  | double * | padfMaxBound )

Definition at line 916 of file shpopen.c.

References SHPInfo::adBoundsMax, SHPInfo::adBoundsMin, SHPInfo::nRecords, SHPInfo::nShapeType, SHPAPI_CALL, and SHPLIB_NULLPTR.

## SHPOpen()

SHPHandle SHPOpen | ( | const char * | pszShapeFile,
|  | const char * | pszAccess )

Definition at line 219 of file shpopen.c.

References SASetupDefaultHooks(), SHPAPI_CALL, and SHPOpenLL().

## SHPOpenDiskTree()

SHPTreeDiskHandle SHPOpenDiskTree | ( | const char * | pszQIXFilename,
|  | const SAHooks * | psHooks )

References SHPAPI_CALL, and SHPOpenDiskTree().

Referenced by SHPOpenDiskTree().

## SHPOpenLL()

SHPHandle SHPOpenLL | ( | const char * | pszShapeFile,
|  | const char * | pszAccess,
|  | const SAHooks * | psHooks )

Definition at line 251 of file shpopen.c.

References SHPInfo::adBoundsMax, SHPInfo::adBoundsMin, SHPInfo::bUpdated, SAHooks::Error, FALSE, SAHooks::FClose, SAHooks::FOpen, SHPInfo::fpSHP, SHPInfo::fpSHX, SAHooks::FRead, SAHooks::FSeek, SAHooks::FTell, MAX, SHPInfo::nFileSize, SHPInfo::nMaxRecords, SHPInfo::nRecords, SHPInfo::nShapeType, SHPInfo::panRecOffset, SHPInfo::panRecSize, SAHooks::pvUserData, SHPInfo::sHooks, SHP_RESTORE_SHX_HINT_MESSAGE, SHP_SWAP32, SHP_SWAP64, SHPAPI_CALL, SHPClose(), SHPLIB_NULLPTR, and STATIC_CAST.

Referenced by SHPOpen(), and SHPOpenLLEx().

## SHPOpenLLEx()

SHPHandle SHPOpenLLEx | ( | const char * | pszShapeFile,
|  | const char * | pszAccess,
|  | const SAHooks * | psHooks,
|  | int | bRestoreSHX )

Definition at line 602 of file shpopen.c.

References SHPAPI_CALL, SHPLIB_NULLPTR, SHPOpenLL(), and SHPRestoreSHX().

## SHPPartTypeName()

const char * SHPPartTypeName | ( | int | nPartType | ) |

Definition at line 2695 of file shpopen.c.

References SHPP_FIRSTRING, SHPP_INNERRING, SHPP_OUTERRING, SHPP_RING, SHPP_TRIFAN, SHPP_TRISTRIP, and SHPPartTypeName().

Referenced by SHPPartTypeName().

## SHPReadObject()

SHPObject * SHPReadObject | ( | const SHPHandle | hSHP,
|  | int | iShape )

Definition at line 1852 of file shpopen.c.

References SHP_SWAP32, SHPLIB_NULLPTR, SHPReadObject(), and STATIC_CAST.

Referenced by SHPReadObject().

## SHPRestoreSHX()

int SHPRestoreSHX | ( | const char * | pszShapeFile,
|  | const char * | pszAccess,
|  | const SAHooks * | psHooks )

Definition at line 623 of file shpopen.c.

References SAHooks::Error, FALSE, SAHooks::FClose, SAHooks::FOpen, SAHooks::FRead, SAHooks::FSeek, SAHooks::FWrite, SAHooks::pvUserData, SHP_SWAP32, SHPAPI_CALL, SHPLIB_NULLPTR, SHPT_ARC, SHPT_ARCM, SHPT_ARCZ, SHPT_MULTIPATCH, SHPT_MULTIPOINT, SHPT_MULTIPOINTM, SHPT_MULTIPOINTZ, SHPT_NULL, SHPT_POINT, SHPT_POINTM, SHPT_POINTZ, SHPT_POLYGON, SHPT_POLYGONM, SHPT_POLYGONZ, STATIC_CAST, and TRUE.

Referenced by SHPOpenLLEx().

## SHPRewindObject()

int SHPRewindObject | ( | const SHPHandle | hSHP,
|  | SHPObject * | psObject )

Definition at line 2856 of file shpopen.c.

References FALSE, tagSHPObject::nParts, tagSHPObject::nSHPType, tagSHPObject::nVertices, tagSHPObject::padfM, tagSHPObject::padfX, tagSHPObject::padfY, tagSHPObject::padfZ, tagSHPObject::panPartStart, SHPAPI_CALL, SHPT_POLYGON, SHPT_POLYGONM, SHPT_POLYGONZ, and TRUE.

## SHPSearchDiskTree()

int * SHPSearchDiskTree | ( | FILE * | fp,
|  | double * | padfBoundsMin,
|  | double * | padfBoundsMax,
|  | int * | pnShapeCount )

References SHPAPI_CALL1, and SHPSearchDiskTree().

Referenced by SHPSearchDiskTree().

## SHPSearchDiskTreeEx()

int * SHPSearchDiskTreeEx | ( | const SHPTreeDiskHandle | hDiskTree,
|  | double * | padfBoundsMin,
|  | double * | padfBoundsMax,
|  | int * | pnShapeCount )

References SHPSearchDiskTreeEx().

Referenced by SHPSearchDiskTreeEx().

## SHPSetFastModeReadObject()

void SHPSetFastModeReadObject | ( | SHPHandle | hSHP,
|  | int | bFastMode )

Definition at line 897 of file shpopen.c.

References assert, SHPInfo::bFastModeReadObject, SHPInfo::psCachedObject, SHPAPI_CALL, SHPLIB_NULLPTR, and STATIC_CAST.

## SHPTreeAddShapeId()

int SHPTreeAddShapeId | ( | SHPTree * | hTree,
|  | SHPObject * | psObject )

References SHPAPI_CALL, and SHPTreeAddShapeId().

Referenced by SHPTreeAddShapeId().

## SHPTreeFindLikelyShapes()

int * SHPTreeFindLikelyShapes | ( | const SHPTree * | hTree,
|  | double * | padfBoundsMin,
|  | double * | padfBoundsMax,
|  | int * | )

References SHPTreeFindLikelyShapes().

Referenced by SHPTreeFindLikelyShapes().

## SHPTreeTrimExtraNodes()

void SHPTreeTrimExtraNodes | ( | SHPTree * | hTree | ) |

References SHPAPI_CALL, SHPAPI_CALL1, and SHPTreeTrimExtraNodes().

Referenced by SHPTreeTrimExtraNodes().

## SHPTypeName()

const char * SHPTypeName | ( | int | nSHPType | ) |

Definition at line 2641 of file shpopen.c.

References SHPT_ARC, SHPT_ARCM, SHPT_ARCZ, SHPT_MULTIPATCH, SHPT_MULTIPOINT, SHPT_MULTIPOINTM, SHPT_MULTIPOINTZ, SHPT_NULL, SHPT_POINT, SHPT_POINTM, SHPT_POINTZ, SHPT_POLYGON, SHPT_POLYGONM, SHPT_POLYGONZ, and SHPTypeName().

Referenced by SHPTypeName().

## SHPWriteHeader()

void SHPWriteHeader | ( | SHPHandle | hSHP | ) |

Definition at line 62 of file shpopen.c.

References SHPInfo::adBoundsMax, SHPInfo::adBoundsMin, ByteCopy, SAHooks::Error, SAHooks::FFlush, SHPInfo::fpSHP, SHPInfo::fpSHX, SAHooks::FSeek, SAHooks::FWrite, SHPInfo::nFileSize, SHPInfo::nRecords, SHPInfo::nShapeType, SHPInfo::panRecOffset, SHPInfo::panRecSize, SHPInfo::sHooks, SHP_SWAP32, SHP_SWAP64, SHPAPI_CALL, SHPLIB_NULLPTR, and STATIC_CAST.

Referenced by SHPClose().

## SHPWriteObject()

int SHPWriteObject | ( | SHPHandle | hSHP,
|  | int | iShape,
|  | const SHPObject * | psObject )

Definition at line 1323 of file shpopen.c.

References SHPInfo::adBoundsMax, SHPInfo::adBoundsMin, assert, tagSHPObject::bMeasureIsUsed, SHPInfo::bUpdated, ByteCopy, tagSHPObject::dfMMax, tagSHPObject::dfMMin, tagSHPObject::dfZMax, tagSHPObject::dfZMin, DISABLE_MULTIPATCH_MEASURE, SAHooks::Error, SHPInfo::fpSHP, SAHooks::FSeek, SAHooks::FTell, SAHooks::FWrite, MAX, MIN, SHPInfo::nFileSize, SHPInfo::nMaxRecords, tagSHPObject::nParts, SHPInfo::nRecords, SHPInfo::nShapeType, tagSHPObject::nSHPType, tagSHPObject::nVertices, tagSHPObject::padfM, tagSHPObject::padfX, tagSHPObject::padfY, tagSHPObject::padfZ, tagSHPObject::panPartStart, tagSHPObject::panPartType, SHPInfo::panRecOffset, SHPInfo::panRecSize, SHPInfo::sHooks, SHP_SWAP32, SHP_SWAP64, SHPAPI_CALL, SHPLIB_NULLPTR, SHPT_ARC, SHPT_ARCM, SHPT_ARCZ, SHPT_MULTIPATCH, SHPT_MULTIPOINT, SHPT_MULTIPOINTM, SHPT_MULTIPOINTZ, SHPT_NULL, SHPT_POINT, SHPT_POINTM, SHPT_POINTZ, SHPT_POLYGON, SHPT_POLYGONM, SHPT_POLYGONZ, STATIC_CAST, and TRUE.

## SHPWriteTree()

int SHPWriteTree | ( | SHPTree * | hTree,
|  | const char * | pszFilename )

References SHPAPI_CALL, and SHPWriteTree().

Referenced by SHPWriteTree().

## SHPWriteTreeLL()

int SHPWriteTreeLL | ( | SHPTree * | hTree,
|  | const char * | pszFilename,
|  | const SAHooks * | psHooks )

References SHPAPI_CALL, and SHPWriteTreeLL().

Referenced by SHPWriteTreeLL().